/*
c:/mingw/bin/gcc -I"c:/program files/R/R-2.9.0/include" -L"C:/Program Files/R/R-2.9.0/bin" -Wall %1.c -o %1.exe -lRlapack -lRblas

Screen Shot ---- 
C:\docs_c_summer_course>gcc -I"c:/program files/R/R-2.9.1/include" -L"C:/Program
 Files/R/R-2.9.1/bin" -Wall ols.c -o ols.exe -lRlapack -lRblas

C:\docs_c_summer_course>ols


X =
1.000000 0.300000
1.000000 -0.200000
1.000000 0.400000
1.000000 -0.500000
1.000000 0.300000

Y =
0.700000
-0.500000
0.900000
-1.100000
0.700000

X'X =
5.000000 0.300000
0.300000 0.630000

(X'X)-1 =
0.205882 -0.098039
-0.098039 1.633987

B0 = 0.003922
B1 = 2.267974


*/
#include <stdio.h>
#include <R_ext/Lapack.h>
#include <R_ext/BLAS.h>

int main(){

	int i,info, ipiv[2];
	char trans = 't', notrans ='n';
	double alpha = 1.0, beta=0.0;
	int ncol=2;
	int nrow=5;
	int one=1;
	double XprimeX[4];
	double X[10] = {1,1,1,1,1,0.3,-0.2,0.4,-0.5,0.3};
	double Y[5] = {0.7,-0.5,0.9,-1.1,0.7};
	double XXinv[4] = {1,0,0,1};
	double XXinvX[10];
	double coef[2];

	printf("\n\nX = ");
	for(i=0;i<5;i++) printf("\n%f %f", X[i],X[i+5]);
	printf("\n\nY = ");
	for(i=0;i<5;i++) printf("\n%f", Y[i]);

	dgemm_(&trans,&notrans,&ncol,&ncol,&nrow,&alpha,X,&nrow,X,&nrow,&beta,XprimeX,&ncol);
	printf("\n\nX'X = ");
	for(i=0;i<2;i++) printf("\n%f %f",XprimeX[i], XprimeX[i+2]);

	dgesv_(&ncol,&ncol,XprimeX,&ncol,ipiv,XXinv,&ncol,&info);
	printf("\n\n(X'X)-1 = ");
	for(i=0;i<2;i++) printf("\n%f %f",XXinv[i], XXinv[i+2]);


//XXinv is 2x2
//X' is 2x5
//X is 5x2

	dgemm_(&notrans,&trans,&ncol,&nrow,&ncol,&alpha,XXinv,&ncol,X,&nrow,&beta,XXinvX,&ncol);

//XXinvX is 2x5
//Y is 5x1

	dgemm_(&notrans,&notrans,&ncol,&one,&nrow,&alpha,XXinvX,&ncol,Y,&nrow,&beta,coef,&ncol);
	printf("\n\nB0 = %f", coef[0]);
	printf("\nB1 = %f\n\n", coef[1]);



	return(0);

}
